#include"stdafx.h"
#include"tspl_printer_base.h"
/////////////////////////////////////
//define 
////////////////////////////////////

//WideCharToMultiByte();//ַתֽ
char* cstringtocharstring(CString str)
{

	int len = WideCharToMultiByte(CP_ACP, 0, str, -1, NULL, 0, NULL, NULL);
	char* ch = new char[len + 1];
	WideCharToMultiByte(CP_ACP, 0, str, -1, ch, len, NULL, NULL);
	return ch;
}
char cstringtochar(CString str)
{
	int len = WideCharToMultiByte(CP_ACP, 0, str, -1, NULL, 0, NULL, NULL);
	char* ch = new char[len + 1];
	WideCharToMultiByte(CP_ACP, 0, str, -1, ch, len, NULL, NULL);
	return ch[0];
}
PrtFormatErrorA                                 FormatErrorA;
PrtFormatErrorW                                 FormatErrorW;
PrtPrinterCreatorA                              PrinterCreatorA;
PrtPrinterCreatorW                              PrinterCreatorW;
PrtPrinterCreatorS                              PrinterCreatorS;
PrtPrinterDestroy                               PrinterDestroy;


PrtPortOpenA                                    PortOpenA;
PrtPortOpenW                                    PortOpenW;
PrtPortClose                                    PortClose;
PrtPrinterInitialize                            PrinterInitialize;
PrtWriteData                                    WriteData;
PrtReadData                                     ReadData;
PrtReadDataEOF                                  ReadDataEOF;

TSPL_SelfTest                                 SelfTest;
TSPL_BitMapA                                  BitMapA;
TSPL_BitMapW                                  BitMapW;
TSPL_Setup                                    Setup;
TSPL_ClearBuffer                              ClearBuffer;
TSPL_Box                                      Box;
TSPL_BarCode                                  BarCode;
TSPL_QrCode                                   QrCode;
TSPL_Text                                     Text;
TSPL_Print                                    pPrint;
TSPL_FormFeed                                 FormFeed;
TSPL_SetTear                                  SetTear;
TSPL_Offset                                   Offset;
TSPL_Direction                                Direction;
TSPL_Feed                                     Feed;
TSPL_Home                                     Home;
TSPL_Learn                                    Learn;
TSPL_GetDllVersion                            GetDllVersion;
TSPL_GetSN                                    GetSN;

void* hprinter;
HMODULE  m_hDll;

void UnloadDll()
{
	FreeLibrary(m_hDll);
}

BOOL LoadDll()
{
	m_hDll = LoadLibrary(_T("TSPL_SDK.dll"));
	if (m_hDll == 0)
		return FALSE;
	FormatErrorA                           = (PrtFormatErrorA)GetProcAddress(m_hDll, "PrtFormatErrorA");
	FormatErrorW                           = (PrtFormatErrorW)GetProcAddress(m_hDll, "PrtFormatErrorW");
	PrinterCreatorA                        = (PrtPrinterCreatorA)GetProcAddress(m_hDll, "PrtPrinterCreatorA");
	PrinterCreatorW                        = (PrtPrinterCreatorW)GetProcAddress(m_hDll, "PrtPrinterCreatorW");
	PrinterCreatorS                        = (PrtPrinterCreatorS)GetProcAddress(m_hDll, "PrtPrinterCreatorS");
	PrinterDestroy                         = (PrtPrinterDestroy)GetProcAddress(m_hDll, "PrtPrinterDestroy");
	PortClose                              = (PrtPortClose)GetProcAddress(m_hDll, "PrtPortClose");
	PrinterInitialize                      = (PrtPrinterInitialize)GetProcAddress(m_hDll, "PrtPrinterInitialize");
	PortOpenA                              = (PrtPortOpenA)GetProcAddress(m_hDll, "PrtPortOpenA");
	PortOpenW                              = (PrtPortOpenW)GetProcAddress(m_hDll, "PrtPortOpenW");
	WriteData                              = (PrtWriteData)GetProcAddress(m_hDll, "PrtWriteData");
	ReadData                               = (PrtReadData)GetProcAddress(m_hDll, "PrtReadData");
	ReadDataEOF                            = (PrtReadDataEOF)GetProcAddress(m_hDll, "PrtReadDataEOF");

	SelfTest                               = (TSPL_SelfTest)GetProcAddress(m_hDll, "TSPL_SelfTest");
	BitMapA                                = (TSPL_BitMapA)GetProcAddress(m_hDll, "TSPL_BitMapA");
	BitMapW                                = (TSPL_BitMapW)GetProcAddress(m_hDll, "TSPL_BitMapW");

	Setup                                  = (TSPL_Setup)GetProcAddress(m_hDll, "TSPL_Setup");
	ClearBuffer                            = (TSPL_ClearBuffer)GetProcAddress(m_hDll, "TSPL_ClearBuffer");

	Box                                    = (TSPL_Box)GetProcAddress(m_hDll, "TSPL_Box");
	BarCode                                = (TSPL_BarCode)GetProcAddress(m_hDll, "TSPL_BarCode");
	QrCode                                 = (TSPL_QrCode)GetProcAddress(m_hDll, "TSPL_QrCode");
	Text                                   = (TSPL_Text)GetProcAddress(m_hDll, "TSPL_Text");
	pPrint                                 = (TSPL_Print)GetProcAddress(m_hDll, "TSPL_Print");
	FormFeed                               = (TSPL_FormFeed)GetProcAddress(m_hDll, "TSPL_FormFeed");
	SetTear                                = (TSPL_SetTear)GetProcAddress(m_hDll, "TSPL_SetTear");
	Offset                                 = (TSPL_Offset)GetProcAddress(m_hDll, "TSPL_Offset");
	Direction                              = (TSPL_Direction)GetProcAddress(m_hDll, "TSPL_Direction");

	Feed                                   = (TSPL_Feed)GetProcAddress(m_hDll, "TSPL_Feed");
	Home                                   = (TSPL_Home)GetProcAddress(m_hDll, "TSPL_Home");
	Learn                                  = (TSPL_Learn)GetProcAddress(m_hDll, "TSPL_Learn");
	GetDllVersion                          = (TSPL_GetDllVersion)GetProcAddress(m_hDll, "TSPL_GetDllVersion");
	GetSN                                  = (TSPL_GetSN)GetProcAddress(m_hDll, "TSPL_GetSN");
	return TRUE;
}