﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;



namespace TestTSPL
{


    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private void button1_Click(object sender, EventArgs e)
        {

            int result = 0;
            tspl_dll dll = new tspl_dll();
           
                       
            dll.printer = tspl_dll.PrtPrinterCreatorS("HM-A300");

            if (dll.printer>0)
            {
                if ((result = tspl_dll.PrtPortOpen(dll.printer, "USB")) == 0)
                {

                    result = tspl_dll.TSPL_Status(dll.printer);
                 
                    if (result == 4)
                    {
                        MessageBox.Show("out of paper", "TestTSPL", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk);
                        return;
                    }
                    else if (result == 65)
                    {
                        MessageBox.Show("cover opened", "TestTSPL", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk);
                        return;
                    }
                    else if (result == 69)
                    {
                        MessageBox.Show("cover opened in Printing", "TestTSPL", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk);
                        return;
                    }
                    //打印机自测  如果需要请先去掉注释
                    //tspl_dll.TSPL_SelfTest(dll.printer);

                   
                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    tspl_dll.TSPL_Setup(dll.printer, 60, 40, 2, 6, 1, 1, 0);

                    result = tspl_dll.TSPL_BarCode(dll.printer, 40, 30, 0, 50, 1, 0, 2, 2, "128");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);

                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    tspl_dll.TSPL_Setup(dll.printer, 60, 40, 2, 6, 1, 2, 0);
                    result = tspl_dll.TSPL_BarCode(dll.printer, 40, 30, 8, 50, 1, 0, 2, 2, "01234567890238");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);

                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    tspl_dll.TSPL_Setup(dll.printer, 60, 40, 2, 6, 1, 2, 0);
                    result = tspl_dll.TSPL_BarCode(dll.printer, 40, 30, 9, 50, 1, 0, 2, 2, "012345678902");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);

                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    tspl_dll.TSPL_Setup(dll.printer, 60, 40, 2, 6, 1, 2, 0);
                    result = tspl_dll.TSPL_BarCode(dll.printer, 40, 30, 17, 50, 1, 0, 2, 2, "01234567811");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);

                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    tspl_dll.TSPL_Setup(dll.printer, 60, 40, 2, 6, 1, 2, 0);
                    result = tspl_dll.TSPL_BarCode(dll.printer, 40, 30, 20, 50, 1, 0, 2, 2, "012345");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);
                  
                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    result = tspl_dll.TSPL_Text(dll.printer, 500, 100, 0, 0, 1, 1, "中国111");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);

                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    result = tspl_dll.TSPL_Text(dll.printer, 200, 160, 0, 0, 1, 1, "TEST ONE");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);
                     
                    tspl_dll.TSPL_Setup(dll.printer, 60, 40, 2, 6, 1, 2, 0);
                    tspl_dll.TSPL_ClearBuffer(dll.printer);
                    result = tspl_dll.TSPL_QrCode(dll.printer,80, 40, 3, 3, 0, 0, 0, 7, "\"10000001\"");
                    result = tspl_dll.TSPL_Print(dll.printer, 1, 1);
                    //如果需要测试图片打印，需要修改图片路径

                    result = tspl_dll.TSPL_BitMap(dll.printer, 80, 50, 0, "F:\\SDKlearning\\0.bmp");


                    result = tspl_dll.PrtPortClose(dll.printer);
                    tspl_dll.PrtPrinterDestroy(dll.printer);
              
                }
                else
                {
                    MessageBox.Show("open port error", "TestTSPL", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk);
                }
            }
            else
            {
                MessageBox.Show(" error model name", "TestTSPL", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk);
            }
        }

        public class tspl_dll
        {
            [DllImport("TSPL_SDK")]
            public static extern int PrtOpenPrinterDriverS(string driverName);

            [DllImport("TSPL_SDK")]
            public static extern int PrtClosePrinterDriver(int hPrinter);

            [DllImport("TSPL_SDK")]
            public static extern int PrtPrinterCreator(ref IntPtr printer, string model);

            [DllImport("TSPL_SDK")]
            public static extern int PrtPrinterCreatorS(string model);

            [DllImport("TSPL_SDK")]
            public static extern int PrtPortOpen(int printer, string portSetting);

            [DllImport("TSPL_SDK")]
            public static extern int PrtPortClose(int printer);

            [DllImport("TSPL_SDK")]
            public static extern int PrtPrinterDestroy(int printer);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_SelfTest(int printer);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Size(int printer, int width, int length);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_BitMap(int printer, int xPos, int yPos, int mode, string fileName);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Setup(int printer, int labelWidth, int labelHeight, int speed, int density, int type, int gap, int offset);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_ClearBuffer(int printer);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_BarCode(int printer, int xPos, int yPos, int codeType, int height, int readable, int rotation, int narrow, int wide, string data);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_QrCode(int printer, int xPos, int yPos, int eccLevel, int width, int mode, int rotation, int model, int mask, string data);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Text(int printer, int xPos, int yPos, int font, int rotation, int xMultiplication, int yMultiplication, string content);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_FormFeed(int printer);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_SetTear(int printer, int on);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Offset(int printer, int distance);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Direction(int printer, int direction);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Feed(int printer, int len, int xPos, int yPos);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Home(int printer);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Print(int printer, int num, int copies);

            [DllImport("TSPL_SDK")]
            public static extern int TSPL_Status(int printer);

            public int printer;
        }

    }
}
